{****************************************************************************
 * The Runner Project                                                       *
 * CopyLeft (C) 2005, Runner Team                                           *
 *                                                                          *
 * R_Mouse.pas -    .  F_Mouse.pas          *
 ****************************************************************************}

Unit R_Mouse;
INTERFACE
Type
  MouseItemType = record
    X1,Y1,X2,Y2: Integer;
    Butt: Word;
    Key : Word
  end;
type
  MouseHandlerType = Procedure(Mask,Buttons,X,Y,DX,DY: Integer);  
const
  LeftButton   = 1;
  RightButton  = 2;
  CenterButton = 4;
  AnyButton    = 7;  
const
  TextRatioX: Byte = 8;
  TextRatioY: Byte = 16;  
FUNCTION IsMouse: Boolean;
FUNCTION InitMouse: Boolean;
PROCEDURE SetMousePage(Page: Byte);
FUNCTION GetMousePage: Byte;
PROCEDURE SetStepToPixel(Hor,Ver: Integer);
PROCEDURE GetStepToPixel(var Hor,Ver: Integer);
PROCEDURE SetDoubleSpeed(Speed: Word);
FUNCTION GetDoubleSpeed: Word;
FUNCTION MouseTextCooX(X: Integer): Byte;
FUNCTION MouseTextCooY(Y: Integer): Byte;
FUNCTION MouseGraphCooX(X: Byte): Integer;
FUNCTION MouseGraphCooY(Y: Byte): Integer;
PROCEDURE MouseWhereXY(var X,Y: Integer);
PROCEDURE MouseGotoXY(X,Y: Integer);
FUNCTION MouseWhereX: Byte;
FUNCTION MouseWhereY: Byte;
FUNCTION MouseIn(X1,Y1,X2,Y2: Integer): Boolean;
FUNCTION NumButton: Byte;
PROCEDURE GetMouseState(var Butt,X,Y: Integer);
FUNCTION MousePressed: Boolean;
PROCEDURE MouseButtPressed(Butt: Integer;var Stat,Count,X,Y: Integer);
PROCEDURE MouseButtReleased(Butt: Integer;var Stat,Count,X,Y: Integer);
PROCEDURE MouseWindow(X1,Y1,X2,Y2: Integer);
PROCEDURE MouseScreen;
PROCEDURE ShowMouse;
PROCEDURE HideMouse;
PROCEDURE MouseTextCursor(ScrMask,CurMask: Word);
PROCEDURE MouseBlink(YUp,YDn: Byte);
PROCEDURE MouseGraphCursor(var ScrCurMask;X,Y: Byte);
FUNCTION MouseBuffSize: Word;
PROCEDURE SaveMouse(var Buff);
PROCEDURE RestoreMouse(var Buff);
PROCEDURE SetMouseItem(NItem: Byte; var Items);
PROCEDURE AddMouseItem(Item: MouseItemType);
PROCEDURE ClearMouseItems;
PROCEDURE GetMouseItem(var NItem: Byte; var Items);
FUNCTION KeyOrMousePressed: Boolean;
FUNCTION ReadKeyOrMouse: Char;
PROCEDURE SetMouseHandler(Mask: Word; Proc: MouseHandlerType);
PROCEDURE ChangeMouseHandler(Mask: Word;  Proc: MouseHandlerType;var OldMask: Word; var OldProc: Pointer);
PROCEDURE ClearMouseHandler;
IMPLEMENTATION
Uses DOS,CRT;
type
  MouseItems = array [1..2*MaxInt div SizeOf(MouseItemType)] of MouseItemType;
  PMouseIt =^MouseItems;
const
  MousePresent: Boolean = False;
  ItemsList   : PMouseIt = NIL;
  NMouseItem  : Byte = 0;
  MouseVisible: Boolean = False;
  x1m: Integer = 0;
  y1m: Integer = 0;
  x2m: Integer = 639;
  y2m: Integer = 199;
  Speed2: Word = 128;
  VerRat: Integer = 8;
  HorRat: Integer = 8;
  NButton: Byte = 0;
var
  Reg: registers;
FUNCTION IsMouse: Boolean;
var
  p    : Pointer;
  k,x,y: Integer;
  Is   : Boolean;
BEGIN
  if NButton=0 then
    begin
      GetIntVec($33,p);
      Is := p<>NIL;
      if Is then with Reg do
        begin
          ax := $3;
          bx := $FFFF;
          Intr($33,Reg);
          Is := bx<>$FFFF
        end;
      MousePresent := Is
    end;
  IsMouse := MousePresent
END; 
FUNCTION InitMouse: Boolean;
BEGIN
  with Reg do
    begin
      ax := 0;
      Intr($33,Reg);
      MousePresent := ax=$FFFF;
      NButton := bx
    end;
  ClearMouseItems;
  SetMousePage(0);
  HideMouse;
  MouseScreen
END;
PROCEDURE SetMousePage(Page: Byte);
BEGIN
  with Reg do
    begin
      ax := $1D;
      bl := Page;
      bh := 0;
      Intr($33,Reg)
    end
END;
FUNCTION GetMousePage: Byte;
BEGIN
  with Reg do
    begin
      ax := $1E;
      Intr($33,Reg);
      GetMousePage := bl
    end
END;
PROCEDURE SetStepToPixel(Hor,Ver: Integer);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $0F;
      cx := Hor and $7FFF;
      dx := Ver and $7FFF;
      HorRat := cx;
      VerRat := dx;
      Intr($33,Reg)
    end
END;
PROCEDURE GetStepToPixel(var Hor,Ver: Integer);
BEGIN
  if IsMouse then with Reg do
    begin
      Hor := HorRat;
      Ver := VerRat
    end
END;
PROCEDURE SetDoubleSpeed(Speed: Word);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $13;
      dx := Speed;
      Speed2 := Speed;
      Intr($33,Reg);
    end
END;
FUNCTION GetDoubleSpeed: Word;
BEGIN
  GetDoubleSpeed := Speed2
END;
FUNCTION MouseTextCooX(X: Integer): Byte;
BEGIN
  MouseTextCooX := X div TextRatioX+1
END;
FUNCTION MouseTextCooY(Y: Integer): Byte;
BEGIN
  MouseTextCooY := Y div TextRatioY+1
END;
FUNCTION MouseGraphCooX(X: Byte): Integer;
BEGIN
  MouseGraphCooX := (X-1)*TextRatioX
END;
FUNCTION MouseGraphCooY(Y: Byte): Integer;
BEGIN
  MouseGraphCooY := (Y-1)*TextRatioY
END;
PROCEDURE MouseWhereXY(var X,Y: Integer);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $3;
      Intr($33,Reg);
      X := cx;
      Y := dx
    end
  else
    begin
      X := -1;
      Y := -1
    end
END;
PROCEDURE MouseGotoXY(X,Y: Integer);
BEGIN
  if IsMouse then with Reg do

    begin
      ax := $4;
      cx := X;
      dx := Y;
      Intr($33,Reg)
    end
END;
FUNCTION MouseWhereX: Byte;
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $3;
      Intr($33,Reg);
      MouseWhereX := MouseTextCooX(cx)
    end
  else
    MouseWhereX := 0
END;
FUNCTION MouseWhereY: Byte;
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $3;
      Intr($33,Reg);
      MouseWhereY := MouseTextCooY(dx)
    end
  else
    MouseWhereY := 0
END;
FUNCTION MouseIn(X1,Y1,X2,Y2: Integer): Boolean;
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $3;
      Intr($33,Reg);
      MouseIn := (cx>=X1) and (cx<=X2) and
                 (dx>=Y1) and (dx<=Y2)
    end
  else
    MouseIn := False
END;
FUNCTION NumButton: Byte;
BEGIN
  NumButton := NButton
END;
PROCEDURE GetMouseState(var Butt,X,Y: Integer);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $3;
      Intr($33,Reg);
      Butt := bx;
      X := cx;
      Y := dx
    end
  else
    begin
      Butt := 0;
      X := 0;
      Y := 0
    end
END;
FUNCTION MousePressed: Boolean;
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $3;
      Intr($33,Reg);
      MousePressed := bx<>0
    end
  else
    MousePressed := False
END;
PROCEDURE MouseButtPressed(Butt: Integer;
                   var Stat,Count,X,Y: Integer);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $5;
      bx := Butt;
      Intr($33,Reg);
      Count := bx;
      X := cx;
      Y := dx;
      Stat := bx
    end
  else
END;
PROCEDURE MouseButtReleased(Butt: Integer;
                   var Stat,Count,X,Y: Integer);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $6;
      bx := Butt;
      Intr($33,Reg);
      Count := bx;
      X := cx;
      Y := dx;
      Stat := bx
    end
  else
END;
PROCEDURE MouseWindow(X1,Y1,X2,Y2: Integer);
BEGIN
  if IsMouse then
    begin
      x1m := X1;
      y1m := Y1;
      x2m := X2;
      y2m := Y2;
      with Reg do
        begin
          ax := $7;
          cx := X1;
          dx := X2;
          Intr($33,Reg);
          ax := $8;
          cx := Y1;
          dx := Y2;
          Intr($33,Reg)
        end
    end
END;
PROCEDURE MouseScreen;
var
  x2,y2: Integer;
BEGIN
  if IsMouse then with Reg do
    begin
      ah := $F;
      Intr($10,Reg);
      case al of
      1,4,5,13: begin
                  x2 := 319;
                  y2 := 199
                end;
      15,16: begin
               x2 := 639;
               y2 := 349
             end;
      17,18: begin
               x2 := 639;
               y2 := 479
             end;
      else
        x2 := 639;
        y2 := 199
      end
    end;
  MouseWindow(0,0,x2,y2)
END;
PROCEDURE ShowMouse;
BEGIN
  if IsMouse and not MouseVisible then
    with Reg do begin
      ax := $1;
      Intr($33,Reg);
      MouseVisible := True
    end
END;
PROCEDURE HideMouse;
BEGIN
  if IsMouse and MouseVisible then with Reg do
    begin
      ax := $2;
      Intr($33,Reg);
      MouseVisible := False
    end
END;
PROCEDURE MouseTextCursor(ScrMask,CurMask: Word);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $A;
      bx := 0;
      cx := ScrMask;
      dx := CurMask;
      Intr($33,Reg)
    end
END;
PROCEDURE MouseBlink(YUp,YDn: Byte);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $A;
      bx := 1;
      cx := YUp;
      dx := YDn;
      Intr($33,Reg)
    end
END;
PROCEDURE MouseGraphCursor(var ScrCurMask;X,Y: Byte);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $9;
      bx := X;
      cx := Y;
      es := seg(ScrCurMask);
      dx := ofs(ScrCurMask);
      Intr($33,Reg)
    end
END;
FUNCTION MouseBuffSize: Word;
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $15;
      bx := 0;
      Intr($33,Reg);
      MouseBuffSize := bx
    end
  else
    MouseBuffSize := 0
END;
PROCEDURE SaveMouse(var Buff);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $16;
      es := seg(Buff);
      dx := ofs(Buff);
      Intr($33,Reg)
    end
END;
PROCEDURE RestoreMouse(var Buff);
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $17;
      es := seg(Buff);
      dx := ofs(Buff);
      Intr($33,Reg)
    end
END;
const
  DoubleChars: Boolean = False;
var
  SecChar: Char;
PROCEDURE SetMouseItem(NItem: Byte; var Items);
BEGIN
  if IsMouse then
    begin
      ClearMouseItems;
      GetMem(ItemsList,NItem*SizeOf(MouseItemType));
      Move(Items,ItemsList^,NItem*SizeOf(MouseItemType));
      NMouseItem := NItem
    end
END;
PROCEDURE AddMouseItem(Item: MouseItemType);
var
  p: PMouseIt;
  k: Byte;
BEGIN
  if IsMouse then
    begin
      k := NMouseItem;
      GetMem(P,(k+1)*SizeOf(MouseItemType));
      Move(ItemsList^,P^,k*SizeOf(MouseItemType));
      Move(Item,P^[k+1],SizeOf(MouseItemType));
      ClearMouseItems;
      NMouseItem := k+1;
      ItemsList := P
    end
END;
PROCEDURE ClearMouseItems;
BEGIN
  if IsMouse and (NMouseItem <>0) then
    begin
      FreeMem(ItemsList,NMouseItem*SizeOf(MouseItemType));
      NMouseItem := 0
    end
END;
PROCEDURE GetMouseItem(var NItem: Byte; var Items);
BEGIN
  if IsMouse and (NMouseItem<>0) then
    begin
      NItem := NMouseItem;
      Move(ItemsList^,Items,NMouseItem*SizeOf(MouseItemType))
    end
END;
FUNCTION KeyOrMousePressed: Boolean;
var
  b,k: Integer;
  MouseActive: Boolean;
BEGIN
  if KeyPressed then
    KeyOrMousePressed := True
  else with Reg do
    begin
      ax := $3;
      Intr($33,Reg);
      if (bx<>0) and (NMouseItem<>0) then
        begin
          MouseActive := False;
          for k := 1 to NMouseItem do
          if not MouseActive then
            with ItemsList^[k] do
           begin
              case Butt of
                LeftButton  : b :=bx and LeftButton;
                RightButton : b :=bx and RightButton;
                CenterButton: b :=bx and CenterButton;
                AnyButton   : b := bx
              else
                b := 0;
              end;
              MouseActive := (b<>0) and
                MouseIn(MouseGraphCooX(X1),MouseGraphCooY(Y1),
                        MouseGraphCooX(X2),MouseGraphCooY(Y2))
            end;
          KeyOrMousePressed := MouseActive
        end
      else
        KeyOrMousePressed := False
    end
END;
FUNCTION ReadKeyOrMouse: Char;
var
  k: Byte;
  b,bb: Word;
  MouseActive: Boolean;
label
  loop;
BEGIN
loop:
  if not IsMouse or KeyPressed then
    ReadKeyOrMouse := ReadKey
  else if DoubleChars then
    begin
      DoubleChars := False;
      ReadKeyOrMouse := SecChar
    end
  else if NMouseItem<>0 then with Reg do
    begin
      MouseActive := False;
      ax := $3;
      Intr($33,Reg);
      bb := bx;
      if bb<>0 then
      for k := 1 to NMouseItem do
        if not MouseActive then
          with ItemsList^[k] do begin
            case Butt of
              LeftButton  : b :=bb and LeftButton;
              RightButton : b :=bb and RightButton;
              CenterButton: b :=bb and CenterButton;
              AnyButton   : b := bb;
            else
              b := 0;
            end;
            if (b<>0) and MouseIn(
                   MouseGraphCooX(X1),MouseGraphCooY(Y1),
                   MouseGraphCooX(X2),MouseGraphCooY(Y2)) then
              begin
                MouseActive := True;
                ReadKeyOrMouse := Char(Lo(Key));
                if Lo(Key)=0 then
                  begin
                    DoubleChars := True;
                    SecChar := chr(Hi(Key))
                  end;
              end
          end;
      if not MouseActive then
        goto loop
    end
  else
    ReadKeyOrMouse := ReadKey
END;
const
  OldUserProc: Pointer = NIL;
var
  UserProc: MouseHandlerType absolute OldUserProc;
  OldAX: Word;
PROCEDURE MouseHandler; Far; Assembler;
ASM
  push bp
  push ds
  push es
  push ax
  mov  ax,SEG @DATA
  mov  ds,ax
  pop  ax
  mov  OldAX,ax
  mov  ax,Word ptr [OldUserProc]
  or   ax,Word ptr [OldUserProc+2]
  jz   @
  mov  ax,OldAX
  push ax
  push bx
  push cx
  push dx 
  push di
  push si
  call [UserProc]
@:  pop  es
  pop  ds
  pop  bp
  ret  far
END;
PROCEDURE SetMouseHandler(Mask: Word; Proc: MouseHandlerType);
BEGIN
  if IsMouse then with Reg do
    begin
      UserProc := Proc;
      ax := $0C;
      cx := Mask;
      es := seg(MouseHandler);
      dx := ofs(MouseHandler);
      Intr($33,Reg)
    end
END;
PROCEDURE ChangeMouseHandler(Mask: Word;
        Proc: MouseHandlerType; var OldMask: Word; var OldProc: Pointer);
BEGIN
  if IsMouse then with Reg do
    begin
      OldProc := OldUserProc;
      ax := $14;
      cx := Mask;
      es := seg(MouseHandler);
      dx := ofs(MouseHandler);
      Intr($33,Reg);
      OldMask := cx
    end
END;
PROCEDURE ClearMouseHandler;
BEGIN
  if IsMouse then with Reg do
    begin
      ax := $0C;
      cx := 0;
      es := 0;
      dx := 0;
      Intr($33,Reg)
    end;
END;
END.